package main

import (
	"log"
	"time"

	"github.com/gomodule/redigo/redis"
)

func main() {

	conn, err := redis.Dial("tcp", "100.80.0.128:6379", redis.DialPassword("foobared"))
	if err != nil {
		log.Fatal(err)
	}
	defer conn.Close()

	keys, _ := redis.Strings(conn.Do("keys", "*"))
	log.Println(keys)

	//conn.Do("set", "abc:starttime", time.Now().Format("2006-01-02 15:04:05"), "NX")
	conn.Do("set", "abc:starttime", time.Now().Format("2006-01-02 15:04:05"))

	starttime, _ := redis.String(conn.Do("GET", "abc:starttime"))
	log.Println(starttime)

	for i := 0; i < 10; i++ {
		conn.Do("LPUSH", "abc:list", i)
	}

	for i := 0; i < 11; i++ {
		r, err := redis.Int64(conn.Do("rpop", "abc:list"))
		if err == nil {
			log.Println(r)
		} else {
			log.Println(err)
		}
	}

	//for i := 0; i < 2; i++ {
	//	log.Println(redis.Strings(conn.Do("BRPOP", "abc:list", 0)))
	//	log.Println(redis.StringMap(conn.Do("BRPOP", "abc:list", 0)))
	//}

	// map
	//conn.Do("hmset", "abc:set", "key1", "val1", "key2", "val2", "key3", "val3")
	conn.Do("hmset", "abc:set", redis.Args{}.Add("key1").Add("val1").Add("key2").Add("val2"))
	s, _ := redis.StringMap(conn.Do("hgetall", "abc:set"))
	log.Println(s)
}
